module Login ( login ) where

import SecLibTypes
import SecLib  
 
import SpwdData
import Spwd
import Maybe

login match  = do let ?match = match 
                  putStrLn "Welcome!"
                  putStr "login:"
                  u <- getLine
                  src <- getSpwdName u 
                  case src of
                     Nothing -> putStrLn "Invalid user!"
                     Just p  -> auth 3 u p


--auth :: --( ?match :: Hatch H (Spwd, Cypher) Bool ) => 
        -- Int -> String -> Sec H Spwd -> IO ()

auth 0 _ spwd = return ()

auth n u spwd =
  do putStr "Password:"
     pwd <- getLine 
     check spwd pwd n u 

check :: ( ?match :: Hatch H L (Spwd, Cypher) Bool ) 
         => Sec H Spwd -> String -> Int -> String -> IO ()

check spwd pwd n u =
  do acc <- ?match ((\s -> (s, pwd)) `fmap` spwd) 
     let b = public (fromJust acc) 
     if b then putStrLn "Launching shell..."
          else do putStrLn "Invalid login!" 
	          auth (n-1) u spwd