module Main ( main ) where

import Policies 
import Files
import SecLib

import Bid 


obtainBid :: File s -> IO () -> IO (Sec s Int)
obtainBid file open = do sec <- run (do r <- s_read file
                                        return (read r :: Int))
                         open 
                         return sec

main 
      = do (hA, openA, closeA, 
            hB, openB, closeB) <- declassification 
           let obtainBidA = obtainBid bidAF openB   
               obtainBidB = obtainBid bidBF openA  
           bid (hA, obtainBidA) (hB, obtainBidB)




