module Main  ( main ) where

obtainBid :: FilePath -> IO Int
obtainBid file = do s <- readFile file 
                    return $ (read s :: Int)

main = do putStrLn "Bid system!"
          putStrLn "-----------"
          putStrLn ""
          putStrLn "Obtaining the bids..."
          a <- obtainBid "bidA" 
          -- writeFile "bidB" (show (a+1))
          b <- obtainBid "bidB" 
          putStrLn $ if a > b then "A wins!"
                              else "B wins!"