module Policies ( declassification ) where

import SecLibTypes 
import Declassification 
import Data


declassification 
 = do (hB  :: (Hatch B L Account Status), authBank) <- who (hatch status)
      (hT  :: (Hatch T L Citizen Address), authTax) <- who (hatch address)
      (hG  :: (Hatch G T Inmigrant Citizen), authG) <- who (hatch inmigrant)
      (hG' :: (Hatch G B Study Result), authG')     <- who (hatch study)
      return ((hB, authBank), (hT, authTax), (hG, authG), (hG', authG'))



